#include <fcntl.h>
#include <unistd.h>
int real_main();
int main() {
	close(0); open("basnik.in", O_RDONLY);
	close(1); open("basnik.out", O_WRONLY | O_CREAT | O_TRUNC, 0666);
	return real_main();
}
#define main real_main

#include <iostream>
#include <vector>
#include <algorithm>

struct Sloka {
	Sloka()
	{}
	
	Sloka(int prvni, int druhy, int poradi)
		: PrvniRym(prvni), DruhyRym(druhy), Poradi(poradi),
		Skupina(-1), Propojeni(-1), Predchozi(-1)
	{}

	int PrvniRym; // slo prvnho rmu sloky
	int DruhyRym; // slo druhho rmu sloky
	short int Poradi; // poad sloky mezi variantami
	short int Skupina; // skupina, do kter sloka pat
	short int Propojeni; // skupina, se kterou je sloka spojen, nebo -1 pokud s dnou
	short int Predchozi; // pedchoz sloka, kvli rekonstrukci een
};

// porovnn podle prvnho rmu
bool PodlePrvniho(const Sloka &leva, const Sloka &prava)
{
	return leva.PrvniRym < prava.PrvniRym;
}

// porovnn podle druhho rmu
bool PodleDruheho(const Sloka &leva, const Sloka &prava)
{
	return leva.DruhyRym < prava.DruhyRym;
}

int main()
{
	int N;
	scanf("%d", &N);

	std::vector<std::vector<Sloka> > V(N); // seznam vech variant

	// naten vstupu
	int maxS = 0, min = 0;
	for (int i=0; i<N; i++) {
		int S;
		scanf("%d", &S);
		if (S > maxS)
			maxS = S;

		for (int j=0; j<S; j++) {
			int a, b;
			scanf("%d%d", &a, &b);
			V[i].push_back(Sloka(a, b, j));
		}

		if (V[i].size() < V[min].size()) { // prbn hledne slo sloky s nejmenm potem variant
			min = i;
		}
	}

	// otome vstup tak, abychom zanali slokou s nejmenm potem variant
	//std::rotate(V.begin(), V.begin() + min, V.end());

	// pedzpracovn
	for (int i=0; i<N-1; i++) {
		std::sort(V[i].begin(), V[i].end(), PodleDruheho); // setdn variant
		std::sort(V[i+1].begin(), V[i+1].end(), PodlePrvniho);

		// nejdve zaadme sloky z V[i] do skupin
		int rym = -1, skupina = -1;
		for (int j=0; j<V[i].size(); j++) {
			if (V[i][j].DruhyRym != rym) {
				V[i][j].Skupina = ++skupina;
				rym = V[i][j].DruhyRym;
			} else {
				V[i][j].Skupina = skupina;
			}
		}

		// nyn spojme sloky z V[i+1] s odpovdajcmi skupinami
		int k = 0, l = 0;
		while (k < V[i].size() && l < V[i+1].size()) {
			if (V[i][k].DruhyRym == V[i+1][l].PrvniRym) {
				V[i+1][l].Propojeni = V[i][k].Skupina;
				++l;
			} else if (V[i][k].DruhyRym < V[i+1][l].PrvniRym) {
				++k;
			} else {
				++l;
			}
		}
	}

	std::vector<short int> skupiny(maxS, -1); // vsledky pro jednotliv skupiny
	std::vector<bool> R(maxS, false); // mnoina R

	for (int prvni=0; prvni<V[0].size(); prvni++) {
		std::fill(R.begin(), R.begin() + V[0].size(), false);

		R[prvni] = true; // postupn zkoume jednotliv varianty prvn sloky

		for (int i=0; i<V.size()-1; i++) {

			std::fill(skupiny.begin(), skupiny.begin() + V[i].size(), -1);
			
			// spotme, kter skupiny obsahuj aspo jednu sloku, kter je v R a rovnou si jednu z nich zapamatujeme
			for (int k=0; k<V[i].size(); k++) {
				if (R[k])
					skupiny[V[i][k].Skupina] = k;
			}
			
			std::fill(R.begin(), R.begin() + V[i+1].size(), false);

			// do R dme ty sloky, kter jsou spojeny se skupinou, kter obsahuje aspo jednu sloku z minul verze R
			for (int k=0; k<V[i+1].size(); k++) {
				if (V[i+1][k].Propojeni >= 0 && skupiny[V[i+1][k].Propojeni] >= 0) {
					V[i+1][k].Predchozi = skupiny[V[i+1][k].Propojeni];
					R[k] = true;
				}
			}
		}

		// nyn mme R spotanou a zjistme, zda lze navzat na prvn sloku
		for (int i=0; i<V[N-1].size(); i++) {
			if (R[i] && V[N-1][i].DruhyRym == V[0][prvni].PrvniRym) {

				// nali jsme een, nyn ho zrekonstruujeme
				std::vector<short int> vysledek(N);
				short int aktualni = i;
				for (int k = N-1; k >= 0; --k) {
					vysledek[k] = V[k][aktualni].Poradi; // kvli tdn slok se pvodn poad mohlo zmnit
					aktualni = V[k][aktualni].Predchozi;
				}

				// vslednou posloupnost musme otoit zptky tak, aby zanala opt pvodn prvn slokou
				//std::rotate(vysledek.begin(), vysledek.begin() + ((vysledek.size() - min) % vysledek.size()), vysledek.end());

				for (int k = 0; k < N; k++) {
					printf("%d\n", vysledek[k] + 1);
				}
				return 0; // stailo najt libovoln een, take meme skonit
			}
		}
	}

	printf("NEEXISTUJE\n"); // pokud se program dostal a sem, tak nenalezl een

	return 0;
}
